﻿using System.Collections;
using UnityEngine;

namespace Mod
{
    public class Behaviour : MonoBehaviour
    {
        private AudioSource Audio;
        private GameObject hand;
        private GameObject handGlow;
        private GameObject handGlow1;
        private RaycastHit2D[] victimBuffer = new RaycastHit2D[128];
        public void Awake()
         {

            hand = gameObject;
            handGlow = new GameObject();
            handGlow.transform.SetParent(gameObject.transform);
            handGlow.transform.localPosition = new Vector3(0, 0f);
            handGlow.transform.localScale = gameObject.transform.parent.localScale;

            var handSprite = handGlow.AddComponent<SpriteRenderer>();

            handSprite.sprite = ModAPI.LoadSprite("th.png");
            handSprite.material = ModAPI.FindMaterial("VeryBright");
            handSprite.color = new Color(0f, 0f, 0f, 0f);
            handSprite.sortingLayerName = "Top";

        }
        public void OnCollisionEnter2D(Collision2D other)
        {
            var rb = gameObject.GetComponent<Rigidbody2D>();

             other.transform.SendMessage("Slice", SendMessageOptions.DontRequireReceiver);
             other.transform.SendMessage("Crush", SendMessageOptions.DontRequireReceiver);
             other.transform.SendMessage("Disintegrate", SendMessageOptions.DontRequireReceiver);
             ModAPI.CreateParticleEffect("Spark", new Vector2(other.transform.position.x, other.transform.position.y));
             ModAPI.CreateParticleEffect("Flash", new Vector2(gameObject.transform.position.x, gameObject.transform.position.y));

           }

        public void FixedUpdate()
        {
            if(hand.GetComponent<Rigidbody2D>().velocity.magnitude >= -100f)
            {
                handGlow.GetComponent<SpriteRenderer>().color = new Color(0f, 0.5f, 1f, Mathf.Clamp(gameObject.GetComponent<Rigidbody2D>().velocity.magnitude / 1f, 0f, 1f));
            }
            else
            {
                handGlow.GetComponent<SpriteRenderer>().color = new Color(0f, 0.5f, 1f, 0f);
            }
        }
    }
}