﻿using System.Collections;
using UnityEngine;

namespace Mod
{
    public class EMP3 : MonoBehaviour
    {
        private AudioSource Audio;
        private GameObject hand;
        private GameObject handGlow;
        private RaycastHit2D[] victimBuffer = new RaycastHit2D[128];
        public void Awake()
         {

            hand = gameObject;
            handGlow = new GameObject();
            handGlow.transform.SetParent(gameObject.transform);
            handGlow.transform.localPosition = new Vector3(0, 0f);
            handGlow.transform.localScale = gameObject.transform.parent.localScale;

            var handSprite = handGlow.AddComponent<SpriteRenderer>();

            handSprite.sprite = ModAPI.LoadSprite("th.png");
            handSprite.material = ModAPI.FindMaterial("VeryBright");
            handSprite.color = new Color(0f, 0f, 0f, 0f);
            handSprite.sortingLayerName = "Top";

        }
        public void OnCollisionEnter2D(Collision2D other)
        {
            var rb = gameObject.GetComponent<BoxCollider2D>().GetComponent<Rigidbody2D>();
            if(rb.velocity.magnitude >= -100f)
            {
             other.transform.GetComponent<PhysicalBehaviour>().Temperature = 80f;
             other.transform.SendMessage("Slice", SendMessageOptions.DontRequireReceiver);
             ModAPI.CreateParticleEffect("Spark", new Vector2(other.transform.position.x, other.transform.position.y));
             ModAPI.CreateParticleEffect("Flash", new Vector2(gameObject.transform.position.x, gameObject.transform.position.y));

         var joint = other.gameObject.AddComponent<FrictionJoint2D>();
         joint.autoConfigureConnectedAnchor = true;
        //joint.enableCollision = false;
         joint.maxForce = 150f;
         joint.connectedBody = gameObject.GetComponent<PhysicalBehaviour>().rigidbody;
         joint.maxTorque = 150f;
         joint.anchor = other.gameObject.GetComponent<PhysicalBehaviour>().transform.InverseTransformPoint(gameObject.transform.position);
         joint.breakForce = 15f;
         joint.breakTorque = 15f;

             other.gameObject.AddComponent<EMP8>();
             gameObject.AddComponent<EMP8>();
       //      gameObject.FixColliders();
            }
            else
            {
                other.gameObject.GetComponent<Rigidbody2D>().velocity = rb.velocity * 0;
            }
        }

        public void FixedUpdate()
        {
            if(hand.GetComponent<Rigidbody2D>().velocity.magnitude >= -100f)
            {
                handGlow.GetComponent<SpriteRenderer>().color = new Color(0f, 0.5f, 1f, Mathf.Clamp(gameObject.GetComponent<Rigidbody2D>().velocity.magnitude / 1f, 0f, 1f));
            }
            else
            {
                handGlow.GetComponent<SpriteRenderer>().color = new Color(0f, 0.5f, 1f, 1f);
            }
        }
      }
  }